diff --git a/gdb/gdbserver/linux-aarch64-low.c b/gdb/gdbserver/linux-aarch64-low.c
index 654b319..4fe023f 100644
--- a/gdb/gdbserver/linux-aarch64-low.c
+++ b/gdb/gdbserver/linux-aarch64-low.c
@@ -46,8 +46,10 @@ extern const struct target_desc *tdesc_aarch64;
 #define AARCH64_PC_REGNO   32
 #define AARCH64_CPSR_REGNO 33
 #define AARCH64_V0_REGNO   34
+#define AARCH64_FPSR_REGNO (AARCH64_V0_REGNO + AARCH64_V_REGS_NUM)
+#define AARCH64_FPCR_REGNO (AARCH64_V0_REGNO + AARCH64_V_REGS_NUM + 1)
 
-#define AARCH64_NUM_REGS (AARCH64_V0_REGNO + AARCH64_V_REGS_NUM)
+#define AARCH64_NUM_REGS (AARCH64_V0_REGNO + AARCH64_V_REGS_NUM + 2)
 
 static int
 aarch64_regmap [] =
@@ -255,6 +257,8 @@ aarch64_fill_fpregset (struct regcache *regcache, void *buf)
 
   for (i = 0; i < AARCH64_V_REGS_NUM; i++)
     collect_register (regcache, AARCH64_V0_REGNO + i, &regset->vregs[i]);
+  collect_register (regcache, AARCH64_FPSR_REGNO, &regset->fpsr);
+  collect_register (regcache, AARCH64_FPCR_REGNO, &regset->fpcr);
 }
 
 static void
@@ -265,6 +269,8 @@ aarch64_store_fpregset (struct regcache *regcache, const void *buf)
 
   for (i = 0; i < AARCH64_V_REGS_NUM; i++)
     supply_register (regcache, AARCH64_V0_REGNO + i, &regset->vregs[i]);
+  supply_register (regcache, AARCH64_FPSR_REGNO, &regset->fpsr);
+  supply_register (regcache, AARCH64_FPCR_REGNO, &regset->fpcr);
 }
 
 /* Enable miscellaneous debugging output.  The name is historical - it
diff --git a/gdb/testsuite/gdb.arch/aarch64-fp.c b/gdb/testsuite/gdb.arch/aarch64-fp.c
new file mode 100644
index 0000000..c52647d
--- /dev/null
+++ b/gdb/testsuite/gdb.arch/aarch64-fp.c
@@ -0,0 +1,38 @@
+/* This file is part of GDB, the GNU debugger.
+
+   Copyright 2008-2014 Free Software Foundation, Inc.
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 3 of the License, or
+   (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
+
+int
+main (void)
+{
+  char buf0[] = {0x10, 0x11, 0x12, 0x13, 0x14, 0x15, 0x16, 0x17,
+                 0x18, 0x19, 0x1a, 0x1b, 0x1c, 0x1d, 0x1e, 0x1f};
+  char buf1[] = {0x20, 0x21, 0x22, 0x23, 0x24, 0x25, 0x26, 0x27,
+                 0x28, 0x29, 0x2a, 0x2b, 0x2c, 0x2d, 0x2e, 0x2f};
+  long val;
+  void *addr;
+    
+  addr = &buf0[0];
+  __asm __volatile ("ldr %x0, [%1]" : "=r" (val) : "r" (&addr));
+  __asm __volatile ("ldr q0, [x0]");
+   
+  addr = &buf1[0];
+  __asm __volatile ("ldr %x0, [%1]" : "=r" (val) : "r" (&addr));
+  __asm __volatile ("ldr q1, [x0]");
+  
+  return 1;
+}
+
diff --git a/gdb/testsuite/gdb.arch/aarch64-fp.exp b/gdb/testsuite/gdb.arch/aarch64-fp.exp
new file mode 100644
index 0000000..c9785a9
--- /dev/null
+++ b/gdb/testsuite/gdb.arch/aarch64-fp.exp
@@ -0,0 +1,85 @@
+# Copyright 2008-2014 Free Software Foundation, Inc.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+#
+# This file is part of the gdb testsuite.
+
+# PR server/17457
+# Test aarch64 floating point registers q0, q1, v0, v1, fpsr, fpcr
+
+if {![istarget "aarch64*"]} {
+    verbose "Skipping ${gdb_test_file_name}."
+    return
+}
+
+standard_testfile
+if { [prepare_for_testing ${testfile}.exp ${testfile} ${srcfile}] } {
+    return -1
+}
+
+if ![runto_main] {
+    untested "could not run to main"
+    return -1
+}
+
+set endianness "little"
+set test "show endian"
+gdb_test_multiple $test $test {
+    -re "(.* )(big|little)( endian.*)$gdb_prompt $" {
+        set endianness $expect_out(2,string)
+        pass "endianness"
+    }
+}
+
+gdb_test "break ${srcfile}:[gdb_get_line_number "return"]" \
+    "Breakpoint $decimal at 0x\[0-9a-fA-F\]+: file .*${srcfile}.*\\\." \
+    "set the breakpoint after setting the fp registers"
+
+gdb_test "continue" \
+    "Continuing.*Breakpoint $decimal.*" \
+    "continue until breakpoint"
+
+if {$endianness == "little"} {
+    set reg_value0 "0x1f1e1d1c1b1a19181716151413121110"
+    set reg_value1 "0x2f2e2d2c2b2a29282726252423222120"
+} else {
+    set reg_value0 "0x101112131415161718191a1b1c1d1e1f"
+    set reg_value1 "0x202122232425262728292a2b2c2d2e2f"
+}
+
+gdb_test "info registers q0" \
+    "q0.*{u = $reg_value0, s = $reg_value0.*" \
+    "check register q0 value"
+
+gdb_test "info registers q1" \
+    "q1.*{u = $reg_value1, s = $reg_value1.*" \
+    "check register q1 value"
+
+gdb_test "info registers v0" \
+    "v0.*$reg_value0}}}" \
+    "check register v0 value"
+
+gdb_test "info registers v1" \
+    "v1.*$reg_value1}}}" \
+    "check register v1 value"
+
+gdb_test "info registers fpsr" \
+    "fpsr.*0x\[0-9a-fA-F\].*" \
+    "check register fpsr value"
+
+gdb_test "info registers fpcr" \
+    "fpcr.*0x\[0-9a-fA-F\].*" \
+    "check register fpcr value"
+